'From Squeak4.4 of 24 December 2012 [latest update: #12324] on 29 December 2012 at 9:37:50 pm'!
Project subclass: #DummyProject
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''
  category: 'System-Support'!

!DummyProject methodsFor: 'as yet unclassified' stamp: 'PavelKrivanek 12/29/2012 21:37'!
invalidate
  ! !

!DummyProject methodsFor: 'as yet unclassified' stamp: 'PavelKrivanek 12/29/2012 21:37'!
restore
  ! !

!DummyProject methodsFor: 'as yet unclassified' stamp: 'PavelKrivanek 12/29/2012 21:37'!
initialize
  changeSet := ChangeSet new.
  transcript := TranscriptStream new.
  displayDepth := Display depth.
  parentProject := nil.
  ! !

Model subclass: #PointerFinder
  instanceVariableNames: 'goal parents toDo toDoNext hasGemStone pointerList objectList parentsSize todoSize depth pointerListIndex'
  classVariableNames: ''
  poolDictionaries: ''
  category: 'System-Support'.

'From Squeak4.4 of 24 December 2012 [latest update: #12324] on 29 December 2012 at 9:22:50 pm'!

!String methodsFor: 'gettext' stamp: 'Richo 5/28/2010 10:39'!
translated
  ^ self! !

'From Squeak4.4 of 24 December 2012 [latest update: #12324] on 29 December 2012 at 12:25:42 pm'!

!SmalltalkImage methodsFor: 'snapshot and quit' stamp: 'dtl 12/28/2009 22:55'!
snapshot: save andQuit: quit embedded: embeddedFlag
  "Mark the changes file and close all files as part of #processShutdownList.
  If save is true, save the current state of this Smalltalk in the image file.
  If quit is true, then exit to the outer OS shell.
  The latter part of this method runs when resuming a previously saved image. This resume logic checks for a document file to process when starting up."
  | resuming msg |
  Object flushDependents.
  Object flushEvents.


  (SourceFiles at: 2) ifNotNil:[
    msg := String streamContents: [ :s |
      s nextPutAll: '----';
      nextPutAll: (save ifTrue: [ quit ifTrue: [ 'QUIT' ] ifFalse: [ 'SNAPSHOT' ] ]
              ifFalse: [quit ifTrue: [ 'QUIT/NOSAVE' ] ifFalse: [ 'NOP' ]]);
      nextPutAll: '----';
      print: Date dateAndTimeNow; space;
      nextPutAll: (FileDirectory default localNameFor: self imageName);
      nextPutAll: ' priorSource: ';
      print: LastQuitLogPosition ].
    self assureStartupStampLogged.
    save ifTrue: [ LastQuitLogPosition := (SourceFiles at: 2) setToEnd; position ].
    self logChange: msg.
    Transcript cr; show: msg
  ].

  Smalltalk processShutDownList: quit.

FileStream stdout nextPutAll: 'Process: ', startUpOrShutDown asString; lf; lf.

  Cursor write show.
  save ifTrue: [resuming := embeddedFlag 
          ifTrue: [self snapshotEmbeddedPrimitive] 
          ifFalse: [self snapshotPrimitive].  "<-- PC frozen here on image file"
        resuming == false "guard against failure" ifTrue:
          ["Time to reclaim segment files is immediately after a save"
          Smalltalk at: #ImageSegment
            ifPresent: [:theClass | theClass reclaimObsoleteSegmentFiles]]]
    ifFalse: [resuming := false].
  quit & (resuming == false) ifTrue: [self quitPrimitive].
  Cursor normal show.
  Smalltalk setGCParameters.
  resuming == true ifTrue: [Smalltalk clearExternalObjects].

  Smalltalk processStartUpList: resuming == true.


  resuming == true ifTrue:[
    self setPlatformPreferences.
    self recordStartupStamp].
FileStream stdout nextPutAll: 'here'.
 " Project current wakeUpTopWindow."
  "Now it's time to raise an error"
  resuming == nil ifTrue: [self error:'Failed to write image file (disk full?)'].
  ^ resuming! !



'From Squeak4.4 of 24 December 2012 [latest update: #12324] on 29 December 2012 at 11:50:18 am'!

!SmalltalkImage methodsFor: 'snapshot and quit' stamp: 'nice 12/27/2009 03:10'!
send: startUpOrShutDown toClassesNamedIn: startUpOrShutDownList with: argument
  "Send the message #startUp: or #shutDown: to each class named in the list.
  The argument indicates if the system is about to quit (for #shutDown:) or if
  the image is resuming (for #startUp:).
  If any name cannot be found, then remove it from the list."

  | removals |

[  FileStream stdout nextPutAll: 'Process: ', startUpOrShutDown asString; lf; lf.
  FileStream stdout nextPutAll: 'classes: ', startUpOrShutDownList asString; lf; lf.] ifError: [].

  removals := OrderedCollection new.
  startUpOrShutDownList do:
    [:name | | class |
    [FileStream stdout nextPutAll: name; lf.] ifError: [].
    class := self at: name ifAbsent: [nil].
    class == nil
      ifTrue: [removals add: name]
      ifFalse: [class isInMemory ifTrue:
            [class perform: startUpOrShutDown with: argument]].
    [FileStream stdout nextPutAll: 'finished...'; lf.] ifError: [].].

  "Remove any obsolete entries, but after the iteration"
  startUpOrShutDownList removeAll: removals.
  FileStream stdout nextPutAll: 'done, saving... '; lf; lf.

! !


'From Squeak4.4 of 24 December 2012 [latest update: #12324] on 29 December 2012 at 10:54:01 am'!

!Behavior methodsFor: 'compiling' stamp: 'ar 2/2/2010 10:02'!
compileAllFrom: oldClass
  "Compile all the methods in the receiver's method dictionary.
  This validates sourceCode and variable references and forces
  all methods to use the current bytecode set"
  | binding |
  "ar 7/10/1999: Use oldClass selectors not self selectors"
  oldClass selectorsDo: [:sel | 
FileStream stdout nextPutAll: 'recompile: ', self asString, ' >> ',sel asString; lf.
self recompile: sel from: oldClass].
  
  "Ensure that we share a common binding after recompilation.
  This is so that ClassBuilder reshapes avoid creating new bindings
  for every method when recompiling a large class hierarchy."
  binding := self binding.
  self methodsDo:[:m|
    m methodClassAssociation == binding 
      ifFalse:[m methodClassAssociation: binding]].
! !



'From Squeak4.4 of 24 December 2012 [latest update: #12324] on 29 December 2012 at 10:46:36 am'!

!Encoder methodsFor: 'encoding' stamp: 'eem 7/27/2008 17:41'!
undeclared: name
  | sym |

  requestor interactive ifTrue:
    [requestor requestor == #error: ifTrue:
      [requestor error: 'Undeclared'].
     ^self notify: 'Undeclared'].
  "Allow knowlegeable clients to squash the undeclared warning if they want (e.g.
   Diffing pretty printers that are simply formatting text).  As this breaks
   compilation it should only be used by clients that want to discard the result
   of the compilation.  To squash the warning use e.g.
    [Compiler format: code in: class notifying: nil decorated: false]
      on: UndeclaredVariableWarning
      do: [:ex| ex resume: false]"
  sym := name asSymbol.
  ^(UndeclaredVariableWarning new name: name selector: selector class: class) signal
    ifTrue:
      [
 FileStream stdout nextPutAll: 'undeclared: ', sym asString, ' put: ', name asString; lf.
Undeclared at: sym put: nil.
      self global: (Undeclared associationAt: sym) name: sym]
    ifFalse:
      [self global: (Association key: sym) name: sym]! !


'From Squeak4.4 of 24 December 2012 [latest update: #12324] on 29 December 2012 at 10:41:54 am'!

!ReadOnlyVariableBinding methodsFor: 'accessing' stamp: 'ar 8/17/2001 18:03'!
value: aValue
  FileStream stdout nextPutAll: 'Cannot store into read-only bindings: ', aValue asString; lf.
value := aValue.
 " (AttemptToWriteReadOnlyGlobal signal: 'Cannot store into read-only bindings') == true ifTrue:[
    value := aValue.
  ]."! !

'From Squeak4.4 of 24 December 2012 [latest update: #12324] on 29 December 2012 at 11:26:30 am'!

!SmalltalkImage methodsFor: 'snapshot and quit' stamp: 'HenrikSperreJohansen 1/21/2011 19:44'!
setPlatformPreferences
  "Set some platform specific preferences on system startup"
  | platform specs |
  Preferences automaticPlatformSettings ifFalse:[^self].
"  SoundPlayer soundQuickStart: SoundPlayer defaultQuickStartForPlatform.
  SoundPlayer stopSoundWhenDone: SoundPlayer defaultStopSoundForPlatform."
  platform := self platformName.
  specs :=  #().
  platform = 'Win32' ifTrue:[
    specs := #()].
  platform = 'Mac OS' ifTrue:[
    specs := #()].
  specs do:[:tuple|
    Preferences setPreference: tuple first toValue: (tuple last == true).
  ].
! !


Object subclass: #UIManager
  instanceVariableNames: 'toolBuilder'
  classVariableNames: ''
  poolDictionaries: ''
  category: 'UIManager'.

Notification subclass: #ProgressInitiationException
  instanceVariableNames: 'workBlock maxVal minVal aPoint progressTitle'
  classVariableNames: 'PreferredProgressBarPosition'
  poolDictionaries: ''
  category: 'UIManager-Support'.

TestCase subclass: #ZipCrcTests
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''
  category: 'Tests-Compression-Streams'.

TestCase subclass: #ZipArchiveTests
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''
  category: 'Tests-Compression-Archives'.

SmallLandColorTheme subclass: #BlueSmallLandColorTheme
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''
  category: 'Morphic-Support'.

Object subclass: #ColorTheme
  instanceVariableNames: ''
  classVariableNames: 'Current'
  poolDictionaries: ''
  category: 'Morphic-Support'.

Object subclass: #ExternalSettings
  instanceVariableNames: ''
  classVariableNames: 'RegisteredClients'
  poolDictionaries: ''
  category: 'Morphic-Support'.

Notification subclass: #FontSubstitutionDuringLoading
  instanceVariableNames: 'familyName pixelSize'
  classVariableNames: ''
  poolDictionaries: ''
  category: 'Morphic-Support'.

SmallLandColorTheme subclass: #GraySmallLandColorTheme
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''
  category: 'Morphic-Support'.

SmallLandColorTheme subclass: #GreenSmallLandColorTheme
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''
  category: 'Morphic-Support'.

Object subclass: #HTTPClient
  instanceVariableNames: ''
  classVariableNames: 'BrowserSupportsAPI RunningInBrowser'
  poolDictionaries: ''
  category: 'Morphic-Support'.

Object subclass: #Imports
  instanceVariableNames: 'imports'
  classVariableNames: ''
  poolDictionaries: ''
  category: 'Morphic-Support'.

SmallLandColorTheme subclass: #MagentaSmallLandColorTheme
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''
  category: 'Morphic-Support'.

Object subclass: #MczInstaller
  instanceVariableNames: 'stream zip'
  classVariableNames: 'Versions'
  poolDictionaries: ''
  category: 'Morphic-Support'.

SmallLandColorTheme subclass: #OrangeSmallLandColorTheme
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''
  category: 'Morphic-Support'.

Object subclass: #PowerManagement
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''
  category: 'Morphic-Support'.

Object subclass: #RealEstateAgent
  instanceVariableNames: ''
  classVariableNames: 'ReverseStaggerOffset StaggerOffset StaggerOrigin StandardSize StandardWindowOrigins'
  poolDictionaries: ''
  category: 'Morphic-Support'.

SmallLandColorTheme subclass: #RedSmallLandColorTheme
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''
  category: 'Morphic-Support'.

SmallLandColorTheme subclass: #VioletSmallLandColorTheme
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''
  category: 'Morphic-Support'.

Object subclass: #WindowColorRegistry
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''
  category: 'Morphic-Support'.

Object subclass: #WindowColorSpec
  instanceVariableNames: 'classSymbol wording brightColor pastelColor helpMessage'
  classVariableNames: ''
  poolDictionaries: ''
  category: 'Morphic-Support'.

ColorTheme subclass: #SmallLandColorTheme
  instanceVariableNames: 'darks normals lights'
  classVariableNames: ''
  poolDictionaries: ''
  category: 'Morphic-Support'.

SmallLandColorTheme subclass: #YellowSmallLandColorTheme
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''
  category: 'Morphic-Support'.

Model subclass: #SARInstaller
  instanceVariableNames: 'zip directory fileName installed'
  classVariableNames: ''
  poolDictionaries: ''
  category: 'Morphic-Support'.

Object subclass: #MethodReference
  instanceVariableNames: 'classSymbol classIsMeta methodSymbol stringVersion category'
  classVariableNames: ''
  poolDictionaries: ''
  category: 'System-Support'.

String organization classify: #displayProgressFrom:to:during: under: '*UIManager-Support'.
String organization classify: #displayProgressAt:from:to:during: under: '*UIManager-Support'.

BitBlt class organization classify: #asGrafPort under: '*Morphic'.

!

!DisplayScreen methodsFor: 'private' stamp: 'pavel.krivanek 11/20/2007 09:28'!
newDepthNoRestore: pixelSize
  
  UIManager default newDisplayDepthNoRestore: pixelSize! !


!SystemOrganizer methodsFor: 'utils' stamp: 'PavelKrivanek 12/28/2012 17:37'!
classesInCategory: category
  ^ (self listAtCategoryNamed: category) collect: [ :className | self class environment at: className ] ! !

!ClassOrganizer methodsFor: 'accessing' stamp: 'PavelKrivanek 12/28/2012 17:40'!
ownCategories

  "get all categories that are not obtained from traits. Order is random"

  | traitsCategories |
  
  traitsCategories := self subject traits inject: Set new into: [:set :trait |
    set addAll: trait organization categories. set ].
  
  ^ (self categories copyWithoutAll: traitsCategories) asArray.
    ! !

'From Squeak4.4 of 24 December 2012 [latest update: #12324] on 28 December 2012 at 6:57:32 pm'!

!SmalltalkImage methodsFor: 'snapshot and quit' stamp: 'PavelKrivanek 12/28/2012 18:57'!
exit: exitStatus
  "Primitive. Exit to another operating system on the host machine, if one
  exists. All state changes in the object space since the last snapshot are lost.
  Essential. See Object documentation whatIsAPrimitive.
  
  Possible values for exitStatus:
  0:   success
  > 1: error"

  <primitive: 113>
  self primitiveFailed! !

'From Squeak4.4 of 24 December 2012 [latest update: #12324] on 28 December 2012 at 6:57:38 pm'!

!SmalltalkImage methodsFor: 'snapshot and quit' stamp: 'PavelKrivanek 12/28/2012 18:57'!
exitFailure
  "Quit the VM with a failing signal.
  Will lose all current changes."
  self exit: 1! !

'From Squeak4.4 of 24 December 2012 [latest update: #12324] on 28 December 2012 at 6:57:42 pm'!

!SmalltalkImage methodsFor: 'snapshot and quit' stamp: 'PavelKrivanek 12/28/2012 18:57'!
exitSuccess
  "Quit the VM with a success signal.
  Will lose all current changes."
  self exit: 0! !

!SystemNavigation methodsFor: 'packages' stamp: 'PavelKrivanek 12/28/2012 17:38'!
allClassesInPackageNamed: packageName
  "Returns the list of classes that belongs to a Monticello package."
  
  "It would be probably better to delegate that query to the package itself"
  | classes organization |
  organization := Smalltalk globals organization.
  classes := (organization classesInCategory: packageName) asSet.
  (organization categoriesMatching: packageName, '-*') do: [:category| 
    classes addAll: (organization classesInCategory: category)].
  ^classes asArray! !

!SystemNavigation methodsFor: 'packages' stamp: 'PavelKrivanek 12/28/2012 17:42'!
removeAllButPackages: packagesList
  "Remove all classes and methods that do not belong to some of listed packages. Skip #unload. Do not use this method if you can use Monticello!! This method is used by some low-level shrinking process. Do not use it. This is quite hackish"

  | keep remove oldRemove extensionCategories |
  keep := Set new.      
  packagesList do: [:pkg | keep addAll: (self allClassesInPackageNamed: pkg)].
  oldRemove := Set new.
  [ 
    remove := Smalltalk globals allClassesAndTraits reject: [:c | keep includes: c].
    remove := remove collect: [:c | c name].
    (remove asSortedCollection: [:a :b | a  <= b ]) do: [:className |
      | class |
      class := (Smalltalk globals classOrTraitNamed: className).
      class allSubclasses ifEmpty: [
        class isTrait ifFalse: [ 
          (class class includesSelector: #unload) ifTrue: [ class removeSelector: #unload ] ].
        FileStream stdout nextPutAll: 'removing ',  class name asString, '...'; lf.
        class removeFromSystem. 
        ] ].

    
    oldRemove ifNotEmpty: [
      oldRemove = remove ifTrue: [          
         self error: 'Some classes still have subclasses: ', (remove collect: [:c | c -> (Smalltalk classOrTraitNamed: c) allSubclasses]) asString ] ].
    oldRemove := remove.
    remove notEmpty] whileTrue.

  keep do: [: class | 
    extensionCategories := (class organization ownCategories select: [:category | 
      category first = $*]) asOrderedCollection.
    extensionCategories removeAllSuchThat: [:category |
      packagesList anySatisfy: [:package |
        ((category asLowercase allButFirst = package asLowercase) or: [package asLowercase, '-*' match: category asLowercase allButFirst])]].
    extensionCategories do: [:category | 
      class removeCategory: category ]. 
    class isTrait ifFalse: [
      extensionCategories := (class class organization ownCategories select: [:category | 
        category first = $*]) asOrderedCollection.
      extensionCategories removeAllSuchThat: [:category |
        packagesList anySatisfy: [:package |
          ((category asLowercase allButFirst = package asLowercase) or: [package asLowercase, '-*' match: category asLowercase allButFirst])]].
      extensionCategories do: [:category | 
        class class removeCategory: category ]]].
      
! !

'From Squeak4.4 of 24 December 2012 [latest update: #12324] on 28 December 2012 at 6:18:26 pm'!


!SmalltalkImage methodsFor: 'SqueakCore' stamp: 'PavelKrivanek 12/28/2012 18:18'!
kernelPackageNames

  ^ #('Balloon' 'Collections'  
'Compiler' 'Compression'  'Environments' 'Exceptions' 'Files' 'FlexibleVocabularies'
  'Graphics' 
  'Kernel' 
   'Multilingual-Encodings' 'Multilingual-ImmPlugin' 'Multilingual-Languages' 'Multilingual-TextConversion' 
  
  'System-Change Notification' 'System-Changes' 'System-FileRegistry' 'System-Finalization' 'System-Localization' 
  'System-Object Events' 'System-Pools' 'System-Support'  'System-Preferences'

 'Traits' 
 'VersionNumber' 'UIManager' 

  'System-Files' )! !

!SmalltalkImage methodsFor: 'SqueakCore' stamp: 'PavelKrivanek 12/28/2012 18:18'!
shrinkToCore

  self shrinkToCoreWith: #().
  
! !

!SmalltalkImage methodsFor: 'SqueakCore' stamp: 'PavelKrivanek 12/28/2012 18:18'!
shrinkToCoreWith: additionalPackageNames

  "
  WARNING:  THIS METHOD WILL DESTROY YOUR IMAGE

  Use with cation and only on fresh Squeak images 
  "

  [ self privShrinkingProcessWith: additionalPackageNames ] forkAt: 40.

  Processor terminateActive.! !

'From Squeak4.4 of 24 December 2012 [latest update: #12324] on 28 December 2012 at 6:18:29 pm'!


!SmalltalkImage methodsFor: 'SqueakCore-private' stamp: 'PavelKrivanek 12/28/2012 18:15'!
privCleanChangeSets

  (ChangeSet allChangeSets reject: [:cs | cs = ChangeSet current]) 
    do: [:cs| ChangeSet removeChangeSet: cs ].

  ChangeSet current clear.
  ChangeSet current name: 'Unnamed1'.! !

!SmalltalkImage methodsFor: 'SqueakCore-private' stamp: 'PavelKrivanek 12/28/2012 18:15'!
privCleanGlobals

  #(ActiveEvent World ActiveWorld ActiveHand ScriptingSystem CustomEventsRegistry ImageImports References ScheduledControllers) do: [:sym |
    Smalltalk globals at: sym put: nil.
     Smalltalk globals removeKey: sym ].! !

!SmalltalkImage methodsFor: 'SqueakCore-private' stamp: 'PavelKrivanek 12/28/2012 18:15'!
privCleanMonticello

  (Smalltalk classNamed: #MCFileBasedRepository) flushAllCaches.
  (Smalltalk classNamed: #MCDefinition) clearInstances.
! !

!SmalltalkImage methodsFor: 'SqueakCore-private' stamp: 'PavelKrivanek 12/28/2012 18:15'!
privCleanProcesses

  "UIManager default terminateUIProcess."

  (Process allInstances select: [:p | 
    ( { 
      "InputEventFetcher default instVarNamed: #fetcherProcess."
      Processor activeProcess.
      WeakArray runningFinalizationProcess.
      Processor backgroundProcess
    } includes: p ) not ])
  do: [:p | p suspend. p terminate ]. 

  Delay startTimerEventLoop.! !

!SmalltalkImage methodsFor: 'SqueakCore-private' stamp: 'PavelKrivanek 12/28/2012 18:15'!
privCleanShutDownList

  #(#TTFileDescription #MCMethodDefinition #InternetConfiguration #TTCFont #ArchiveViewer #CPUWatcher 
#ProcessBrowser #ExternalSettings "#Symbol" #SecurityManager "#FileStream" "#AutoStart" #CommandHistory 
#EToyListenerMorph #ImageSegment #Password #HttpUrl #SoundPlayer "#FileDirectory" "#Color" #StrikeFont 
#PasteUpMorph #ControlManager "#Form" "#InputSensor" "#DisplayScreen" "#Delay" "#MessageTally" #BaseSoundSystem) do: [:className |
    Smalltalk removeFromShutDownList: (Smalltalk classNamed: className)].! !

!SmalltalkImage methodsFor: 'SqueakCore-private' stamp: 'PavelKrivanek 12/28/2012 18:15'!
privCleanStartUpList

  #("#MessageTally" "#Delay" "#DisplayScreen" "#Cursor" "#InputSensor" "#ProcessorScheduler" "#FileDirectory" 
#NaturalLanguageTranslator #ShortIntegerArray #ShortRunArray "#CrLfFileStream" #LanguageEnvironment 
#ControlManager #PasteUpMorph #ImageSegment #EToyListenerMorph #PowerManagement #ExternalSettings
 #SecurityManager "#FileStream" "#AutoStart" "#UUIDGenerator" #ProcessBrowser #CPUWatcher "#DateAndTime" 
#SmalltalkImage #Utilities #MenuIcons "#WeakArray" "#MultiByteFileStream" #InternetConfiguration 
#KedamaPatchMorph "#Locale" #CommandHistory #MCWorkingCopy "#Collection" #HostWindowProxy #NetNameResolver #SoundPlayer) 
  do: [:className |
    Smalltalk removeFromStartUpList: (Smalltalk classNamed: className)].! !

!SmalltalkImage methodsFor: 'SqueakCore-private' stamp: 'PavelKrivanek 12/28/2012 18:16'!
privCleanTextConstants
"
  TextConstants TextSharedInformation removeKey: #DefaultTextStyle.
  TextConstants TextSharedInformation removeKey: #DefaultMultiStyle.
  TextConstants TextSharedInformation removeKey: #DefaultFixedTextStyle.
  TextConstants TextSharedInformation removeKey: (Smalltalk classNamed: #StrikeFont) defaultFontKey.
"

  #(Accujen Atlanta Accuny BitstreamVeraSansMono BitstreamVeraSerif Accumon DefaultTextStyle Accusf
    Accuve ComicSansMS 'Bitmap DejaVu Sans' DefaultFixedTextStyle DefaultEditMenu CaretForm Accushi
    Accula Accuat BitstreamVeraSans DefaultMultiStyle ) do: [:key | TextConstants removeKey: key ].

  Smalltalk allClasses select: [:c | c sharedPools includes: TextConstants] thenDo: [:c | c compileAll ].! !

!SmalltalkImage methodsFor: 'SqueakCore-private' stamp: 'PavelKrivanek 12/28/2012 18:16'!
privCleanUnloadMethods

  " remove class unload methods to avoid their calling during removing of this classes "

  #(#Browser #ChangeList  #DummySoundSystem 
  #FileContentsBrowser #GZipReadStream #GZipWriteStream #MCVersionReader 
  #MailComposition #Morph
  #DefaultExternalDropHandler #FileStream #Form 
  #PreferenceBrowser #UUniverseBrowser #UUniverseEditor GeeMailMorph) 
    do: [:className | (Smalltalk at: className) class removeSelector: #unload. ].! !

!SmalltalkImage methodsFor: 'SqueakCore-private' stamp: 'PavelKrivanek 12/28/2012 18:16'!
privRecompileAll

  Smalltalk allClassesAndTraits do: [:classOrTrait | [classOrTrait compileAll] ifError: [] ].
! !

!SmalltalkImage methodsFor: 'SqueakCore-private' stamp: 'PavelKrivanek 12/28/2012 18:17'!
privShrinkingProcess

  self privShrinkingProcessWith: #().



! !

!SmalltalkImage methodsFor: 'SqueakCore-private' stamp: 'PavelKrivanek 12/28/2012 18:17'!
privShrinkingProcessWith: additionalPackageNames

[
    | packages |
        
    10 timesRepeat: [
      (Delay forMilliseconds: 100) wait.
      Processor yield ].

    Utilities authorName: 'Mr.Shrinker'.
  
     FileStream stdout nextPutAll: '1'; lf.
   self privCleanMonticello.
    FileStream stdout nextPutAll: '2'; lf.
Project classPool at: #CurrentProject put: DummyProject new.
Project classPool at: #AllProjects put: {Project classPool at: #CurrentProject}.
    Project current instVarNamed: #uiManager put: DummyUIManager new.



    FileStream stdout nextPutAll: '3'; lf.

    (Smalltalk at: #ProjectLauncher) deactivate.
    ScriptLauncher activate.

   
    FileStream stdout nextPutAll: '4'; lf.

    self privCleanProcesses.
    self privCleanGlobals.

SystemChangeNotifier uniqueInstance noMoreNotificationsFor: (Smalltalk at: #ServiceRegistry).
SystemChangeNotifier uniqueInstance noMoreNotificationsFor: (Smalltalk at: #MCWorkingCopy).
SystemChangeNotifier uniqueInstance noMoreNotificationsFor: (Smalltalk at: #TestCase).

  Project classPool at: #UIProcess put: nil.


    FileStream stdout nextPutAll: '5'; lf.
    5 timesRepeat: [Smalltalk garbageCollect].

    (Smalltalk classNamed: #MCDataStream) initialize.
    FileStream stdout nextPutAll: '6'; lf.

    Beeper instVarNamed: #default put: nil.
    FileStream stdout nextPutAll: '7'; lf.

    Smalltalk cleanOutUndeclared.
    FileStream stdout nextPutAll: '8'; lf.

    5 timesRepeat: [Smalltalk garbageCollect].
  
  "  self privShrinkUnicodeTables."



  #(GB2312Table JISX0208Table KSX1001Table) do: [:table| UCSTable classPool at: table put: nil ].

  Unicode classPool at: #DecimalProperty put: #(-1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 0 1 2 3 4 5 6 7 8 9 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1).

  Unicode classPool at: #GeneralCategory put: #(1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 29 21 21 21 23 21 21 21 22 18 21 25 21 17 21 21 13 13 13 13 13 13 13 13 13 13 21 21 25 25 25 21 21 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 22 21 18 24 16 24 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 22 25 18 25 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 29 21 23 23 23 23 26 26 24 26 5 20 25 17 26 24 26 25 15 15 24 5 26 21 24 15 5 19 15 15 15 21 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 25 9 9 9 9 9 9 9 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 25 5 5 5 5 5 5 5).


    Display newDepth: 1.
    FileStream stdout nextPutAll: '9'; lf.

    self privCleanStartUpList.
    self privCleanShutDownList.
    FileStream stdout nextPutAll: '10'; lf.



    "move class Model to different category"
"    Object subclass: #Model instanceVariableNames: 'dependents' classVariableNames: '' poolDictionaries: '' category: 'Kernel-Objects'.
"
    self privCleanTextConstants.

   FileStream stdout nextPutAll: '11'; lf.
    (Smalltalk classNamed: #SoundService) default: nil.
    (Smalltalk classNamed: #SoundService) unregister: (Smalltalk classNamed: #DummySoundSystem).

   FileStream stdout nextPutAll: '12'; lf.

"   ThreadSafeTranscript install."

    self privCleanUnloadMethods.
  FileStream stdout nextPutAll: '13'; lf.

"    (Smalltalk classNamed: #RPackageOrganizer) unregisterInterestToSystemAnnouncement.

 "   SystemNavigation new removeAllButPackages: self kernelPackageNames, additionalPackageNames.

   FileStream stdout nextPutAll: '14'; lf.
   Smalltalk flushClassNameCache.
    3 timesRepeat: [
      Smalltalk garbageCollect.
        Symbol compactSymbolTable.].

Project allInstances do: [:p | p instVarNamed: #world put: nil.].

Preferences classPool at: #Parameters put:  IdentityDictionary new.

Preferences removePreference: #cpuWatcherEnabled.
Preferences removePreference: #gradientScrollBars.
Preferences removePreference: #alternativeButtonsInScrollBars.
Preferences removePreference: #automaticFlapLayout.
Preferences removePreference: #navigatorOnLeftEdge.
Preferences removePreference: #classicNavigatorEnabled.
Preferences removePreference: #allowEtoyUserCustomEvents.
Preferences removePreference: #syntaxHighlightingAsYouTypeAnsiAssignment.
Preferences removePreference: #syntaxHighlightingAsYouTypeLeftArrowAssignment.


    FileStream stdout nextPutAll: '15'; lf.
   Undeclared removeUnreferencedKeys.
    FileStream stdout nextPutAll: '16'; lf.
    self privRecompileAll.
    FileStream stdout nextPutAll: '17'; lf.
    
    self privCleanChangeSets.
      FileStream stdout nextPutAll: '18'; lf.
  
    FileServices removeObsolete.
      FileStream stdout nextPutAll: '19'; lf.

    Object flushEvents.

   " (Smalltalk classNamed: #MCDataStream) initialize."

    Locale classPool at: #LocaleChangeListeners put: nil.
  
    
  FileStream stdout nextPutAll: '20'; lf.

    Behavior flushObsoleteSubclasses.
    Smalltalk flushClassNameCache.
    Smalltalk organization removeEmptyCategories.
  FileStream stdout nextPutAll: '21'; lf.



    WeakArray restartFinalizationProcess.
   " SmalltalkImage current fixObsoleteReferences."

    "Smalltalk condenseChanges."
  FileStream stdout nextPutAll: '22'; lf.

    Smalltalk saveImageInNewContext.

  ] ifError: [:e |
    | rep |
    rep := FileStream forceNewFileNamed: 'SqueakDebug.log'.
    rep nextPutAll: 'SqueakCore shrinking report'; cr.
    rep nextPutAll: 'Error:'; cr.
    rep nextPutAll: e asString; cr.
    rep nextPutAll: thisContext stack size asString.
    thisContext stack copy withIndexDo: [:stck :i |
    [ rep nextPutAll: i asString; space; nextPutAll: stck asString; cr] ifError: []].
    rep close. 
    Smalltalk exitFailure ] ! !


!SmalltalkImage methodsFor: 'private' stamp: 'PavelKrivanek 12/28/2012 18:42'!
privSaveImageWithCleanup

  " Do not use this method for common image saving. This method is designated for saving the image during the shrinking process in headless images."

  | report |

  (Delay forMilliseconds: 1000) wait.

  Processor yield.

 13 "a magic number (Camillo) "timesRepeat: [ Smalltalk garbageCollect ].
 
  [
    self snapshot: true andQuit: true.
  ] ifError: [:e |
    [ report := FileStream forceNewFileNamed: 'SqueakDebug.log'.
    report nextPutAll: e asString; cr.
    ] ensure: [ report ifNotNil: [report close]].
  ]! !

!SmalltalkImage methodsFor: 'private' stamp: 'PavelKrivanek 12/28/2012 18:42'!
saveImageInNewContext

  " This method is used for saving the Smalltalk image in a new process so the current process with all stack information may be forgotten.
  
  Do not use this method for common image saving. This method is designated for saving the image during the shrinking process in headless images. "

  [ self privSaveImageWithCleanup ] forkAt: 40.! !








'From Pharo2.0a of ''18 April 2012'' [Latest update: #20451] on 28 December 2012 at 6:32:30 pm'!
UIManager subclass: #DummyUIManager
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''
  category: 'UIManager'!
!DummyUIManager commentStamp: 'LaurentLaffont 2/23/2011 20:16' prior: 0!
I'm an alternative UIManager used to run an the image without GUI.  I redefine methods which requires user input as these requests are irrelevant in a headless environment. !


!DummyUIManager methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 9/7/2011 21:21'!
multiLineRequest: queryString initialAnswer: defaultAnswer answerHeight: answerHeight! !


!DummyUIManager methodsFor: 'default actions' stamp: 'pavel.krivanek 5/31/2007 08:20'!
fileDoesNotExistsDefaultAction: anException
! !

!DummyUIManager methodsFor: 'default actions' stamp: 'pavel.krivanek 5/31/2007 08:20'!
fileExistsDefaultAction: anException
! !

!DummyUIManager methodsFor: 'default actions' stamp: 'pavel.krivanek 5/31/2007 08:20'!
lowSpaceWatcherDefaultAction

  Transcript show: '*** LOW SPACE ***'; cr.
! !

!DummyUIManager methodsFor: 'default actions' stamp: 'pavel.krivanek 5/31/2007 08:20'!
syntaxErrorNotificationDefaultAction: anException

  Transcript show: '*** SYNTAX ERROR ***'; cr.
  Transcript show: anException; cr.
  Transcript show: (thisContext stack first: (20 min: thisContext stack size)); cr.
  anException return.! !

!DummyUIManager methodsFor: 'default actions' stamp: 'pavel.krivanek5/31/2007 08:20'!
unhandledErrorDefaultAction: anException

  Transcript show: '*** EXCEPTION ***'; cr.
  Transcript show: anException; cr.
  Transcript show: (thisContext stack first: (20 min: thisContext stack size)); cr.
  anException isResumable ifTrue: [ anException resume ]
! !

!DummyUIManager methodsFor: 'default actions' stamp: 'pavel.krivanek 5/11/2008 17:44'!
warningDefaultAction: anException

  ^ self unhandledErrorDefaultAction: anException! !


!DummyUIManager methodsFor: 'display' stamp: 'pavel.krivanek 5/31/2007 08:20'!
checkForNewDisplaySize

  Display extent = DisplayScreen actualScreenSize ifTrue: [^ self].
  DisplayScreen startUp.
! !

!DummyUIManager methodsFor: 'display' stamp: 'pavel.krivanek 5/31/2007 08:20'!
newDisplayDepthNoRestore: pixelSize

  "Change depths.  Check if there is enough space!!  , di"
  | area need |
  pixelSize = Display depth ifTrue: [^ self  "no change"].
  pixelSize abs < Display depth ifFalse:
    ["Make sure there is enough space"
    area := Display boundingBox area. "pixels"

    need := (area * (pixelSize abs - Display depth) // 8)  "new bytes needed"
        + Smalltalk lowSpaceThreshold.
    (Smalltalk garbageCollectMost <= need
      and: [Smalltalk garbageCollect <= need])
      ifTrue: [self error: 'Insufficient free space']].
  Display setExtent: Display extent depth: pixelSize.

  DisplayScreen startUp! !

!DummyUIManager methodsFor: 'display' stamp: 'pavel.krivanek 5/31/2007 08:20'!
restoreDisplay! !

!DummyUIManager methodsFor: 'display' stamp: 'pavel.krivanek 5/31/2007 08:20'!
restoreDisplayAfter: aBlock

  aBlock value.
  Sensor waitButton.! !


!DummyUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 5/31/2007 08:20'!
chooseDirectory: label from: dir

  ^ nil! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 5/31/2007 08:20'!
chooseFrom: aList lines: linesArray title: aString

  ^ aList first! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 5/31/2007 08:20'!
chooseFrom: labelList values: valueList lines: linesArray title: aString

  ^ valueList first! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'MarcusDenker 4/29/2011 00:33'!
confirm: queryString

  (ProvideAnswerNotification signal: queryString) ifNotNil: [:answer |
    ^answer].

  self error: 'No user response possible'! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'MarcusDenker 4/29/2011 00:33'!
confirm: aString orCancel: cancelBlock

  (ProvideAnswerNotification signal: aString) ifNotNil: [:answer |
    ^answer == #cancel ifTrue: [cancelBlock value] ifFalse: [answer]].

  self error: 'No user response possible'! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 5/31/2007 08:20'!
edit: aText label: labelString accept: anAction

  ^ nil! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 5/31/2007 08:23'!
fontFromUser: priorFont

  self error: 'No user response possible'! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'CamilloBruni 9/22/2012 20:17'!
inform: aString
  "Nothing to be done here"! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'SeanDeNigris 6/20/2012 23:32'!
informUserDuring: aBlock

  aBlock value: DummySystemProgressItem new.! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'SeanDeNigris 6/22/2012 09:35'!
progressInitiationExceptionDefaultAction: anException

  | result |

  result := anException workBlock value: DummySystemProgressItem new.

  anException resume: result.! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'PavelKrivanek 11/19/2012 13:12'!
request: queryString initialAnswer: defaultAnswer 

  ^ self request: queryString initialAnswer: defaultAnswer title: 'Provide the following information' entryCompletion: nil
! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'PavelKrivanek 11/19/2012 13:10'!
request: aStringOrText initialAnswer: defaultAnswer entryCompletion: anEntryCompletion
  
  ^ self request: aStringOrText initialAnswer: defaultAnswer title: 'Information Required' translated entryCompletion: anEntryCompletion
! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'PavelKrivanek 11/19/2012 13:13'!
request: aStringOrText initialAnswer: defaultAnswer title: aTitle entryCompletion: anEntryCompletion

  (ProvideAnswerNotification signal: aStringOrText) ifNotNil: [:answer |
    ^ answer == #default ifTrue: [defaultAnswer] ifFalse: [answer]].
  
  self error: 'No user response possible'! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 5/31/2007 08:20'!
requestPassword: queryString
  
  ^ self request: queryString initialAnswer: ''! !


!DummyUIManager methodsFor: 'ui requests' stamp: 'cmm 5/27/2011 14:05'!
displayProgress: titleString at: aPoint from: minVal to: maxVal during: workBlock 

  ^ workBlock value: Association new! !


'From Squeak4.4 of 24 December 2012 [latest update: #12324] on 28 December 2012 at 9:41:26 pm'!
AbstractLauncher subclass: #ScriptLauncher
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''
  category: 'System-Support'!

!ScriptLauncher methodsFor: 'as yet unclassified' stamp: 'PavelKrivanek 12/28/2012 21:41'!
startUp

  | scriptName prefix |

  prefix := 'file://'.

  Preferences readDocumentAtStartup ifTrue: [
    scriptName := (SmalltalkImage current getSystemAttribute: 2) ifNil:[''].
    scriptName := scriptName convertFromSystemString.
      scriptName isEmpty ifFalse:[
        (scriptName asLowercase beginsWith: prefix)
          ifTrue: [scriptName := scriptName allButFirst: prefix size].
        (FileStream readOnlyFileNamed: scriptName) fileIn]].! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ScriptLauncher class
  instanceVariableNames: ''!

!ScriptLauncher class methodsFor: 'as yet unclassified' stamp: 'PavelKrivanek 12/28/2012 21:40'!
initialize

  self activate.! !

'From Squeak4.4 of 24 December 2012 [latest update: #12324] on 28 December 2012 at 9:46:59 pm'!

!AutoStart class methodsFor: 'initialization' stamp: 'PavelKrivanek 12/28/2012 21:46'!
startUp: resuming
  "The image is either being newly started (resuming is true), or it's just been snapshotted.
  If this has just been a snapshot, skip all the startup stuff."

  | startupParameters launchers |
  self active ifTrue: [^self].
  self active: true.
  resuming ifFalse: [^self].

  "HTTPClient determineIfRunningInBrowser."
  startupParameters := Smalltalk namedArguments.
  "(startupParameters includesKey: 'apiSupported' asUppercase )
    ifTrue: [
      HTTPClient browserSupportsAPI: ((startupParameters at: 'apiSupported' asUppercase) asUppercase = 'TRUE').
      HTTPClient isRunningInBrowser
        ifFalse: [HTTPClient isRunningInBrowser: true]].
  self checkForUpdates
    ifTrue: [^self].
  self checkForPluginUpdate."
  launchers := self installedLaunchers collect: [:launcher |
    launcher new].
  launchers do: [:launcher |
    launcher parameters: startupParameters].
  "launchers do: [:launcher |
    Smalltalk at: #WorldState ifPresent: [ :ws | ws addDeferredUIMessage: [launcher startUp]]]"
  launchers do: [:launcher |
    launcher startUp]! !



SystemOrganizer default renameCategory: 'Tests-Utilities' toBe: 'SUnit-Core-Utilities'.



"---------------------------------------------------------------------"



SmalltalkImage current shrinkToCore.